VERSION 5.00
Object = "{3B7C8863-D78F-101B-B9B5-04021C009402}#1.2#0"; "RICHTX32.OCX"
Begin VB.Form frmPC5 
   Caption         =   " PC5 Information"
   ClientHeight    =   7680
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   4695
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   ScaleHeight     =   7680
   ScaleWidth      =   4695
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdDP5SetText 
      Caption         =   "DP5 Set Text"
      Height          =   375
      Left            =   2520
      TabIndex        =   12
      Top             =   5160
      Width           =   1215
   End
   Begin VB.CommandButton cmdDP5GetText 
      Caption         =   "DP5 Get Text"
      Height          =   375
      Left            =   960
      TabIndex        =   11
      Top             =   5160
      Width           =   1215
   End
   Begin VB.TextBox txtDP5Text 
      Height          =   1935
      Left            =   120
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   10
      Top             =   5640
      Width           =   4455
   End
   Begin VB.Frame fraBitShiftingFunctions 
      Caption         =   "Bit Shifting Functions"
      Height          =   1815
      Left            =   720
      TabIndex        =   3
      Top             =   3240
      Width           =   3255
      Begin VB.TextBox txtHex 
         Alignment       =   2  'Center
         Height          =   285
         Left            =   1080
         TabIndex        =   9
         Top             =   480
         Width           =   1455
      End
      Begin VB.CommandButton cmdShiftLeft 
         Caption         =   "<<"
         Height          =   255
         Left            =   1320
         TabIndex        =   8
         ToolTipText     =   "Shift Left"
         Top             =   840
         Width           =   375
      End
      Begin VB.CommandButton cmdShiftRight 
         Caption         =   ">>"
         Height          =   255
         Left            =   1920
         TabIndex        =   7
         ToolTipText     =   "Shift Right"
         Top             =   840
         Width           =   375
      End
      Begin VB.CommandButton cmdLoad 
         Caption         =   "*"
         Height          =   255
         Left            =   600
         TabIndex        =   6
         ToolTipText     =   "Load Sample Data"
         Top             =   480
         Width           =   375
      End
      Begin VB.TextBox txtSL 
         Alignment       =   2  'Center
         Height          =   285
         Left            =   1320
         TabIndex        =   5
         Text            =   "1"
         ToolTipText     =   "Shift Left Positions"
         Top             =   1200
         Width           =   375
      End
      Begin VB.TextBox txtSR 
         Alignment       =   2  'Center
         Height          =   285
         Left            =   1920
         TabIndex        =   4
         Text            =   "1"
         ToolTipText     =   "Shift Right Positions"
         Top             =   1200
         Width           =   375
      End
   End
   Begin VB.CommandButton cmdClearStatus 
      Caption         =   "Clear Status"
      Height          =   255
      Left            =   720
      TabIndex        =   1
      Top             =   2880
      Width           =   3255
   End
   Begin VB.CommandButton cmdGetPC5Status 
      Caption         =   "PX4 SDD, PC5 Status"
      Height          =   375
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   4455
   End
   Begin RichTextLib.RichTextBox rtbStatus 
      Height          =   2175
      Left            =   120
      TabIndex        =   2
      Top             =   600
      Width           =   4455
      _ExtentX        =   7858
      _ExtentY        =   3836
      _Version        =   393217
      ScrollBars      =   2
      TextRTF         =   $"frmPC5.frx":0000
   End
End
Attribute VB_Name = "frmPC5"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Declare Sub Sleep Lib "kernel32" (ByVal dwMilliseconds As Long)

'PC5 Status Example
'
'Demonstrates:
'   1. PX4 SDD Support Detection (Negative HV)
'   2. Detect PC5
'   3. Get PC5 PreAmp Jumper Setting
'   4. Get PC5 HV Polarity Setting
'   5. Check for PC5 HV Polarity Error
'   6. DP5 Text Functions

Private Const isBufferA = 1     'ADMCA/DPPAPI use bufferA,DP5 does not support buffer select
Private SetBits(0 To 31) As Long

'Status packet BootBlock From Status Block        'DPP5 20071105
Private bb_DeadTimeCounter As Long          '&H2F-&H2C deadtime counter 50nS/count
Private bb_DiodeCalDACSet As Long           '&H30-31 Diode Cal DAC setting
Private bb_TECCurrentLimit As Long          '&H32-33 TEC current limit DAC setting (not used in DP5)
Private bb_BootFlags As Long                '&H34-35 Boot flags (MSB currently unused)
Private bb_HVDACSet As Long                 '&H36-37 HV DAC setting (not used in PX4 mode)
Private bb_TECDACSet As Long                '&H38-39 TEC DAC setting (not used in PX4 mode)
Private bb_InputOffsetTuning As Long        '&H3A-3B Input offset DAC setting (not used in PX4 mode) (not currently used - testing to see if constant value works)
Private bb_uCTempCal As Long                '&H3C-3D uC temp cal, or something like that (not used yet)
Private bb_SpectrumOffset As Long           '&H3E-3F Spectrum offset (not used yet, added a boot flag bit (D1) to indicate whether to use this)
Private NeedsDP5ReBoot As Long
Private b80MHzMode As Long
Private bConfigHVPolarity As Long
Private bPC5Detected As Long
Private bBootHVPolarity As Long
Private strHVMonitor As String
Private Const vbDarkGreen = &H8000&     'RGB(0, 128, 0)
Private Const vbBlueViolet = &H8A2BE2   'RGB(138, 43, 226)
Private Const vbCoral = &HFF7F50        'RGB(255, 127, 80)
Private Const vbSteelBlue = &H4682B4
Private Const vbSlateBlue = &H6A5ACD

Private HVPolarityError As Boolean
Private Firmware As Long
Private HVMonitor As Double

Private Sub cmdClearStatus_Click()
    ClearStatusList
End Sub

Private Sub cmdDP5GetText_Click()
    Dim NumDev As Integer       'number of usb devices
    Dim objDppApi As Long       'pointer to dpp api
    Dim strDeviceType As String 'device type name
    Dim USBDevNum As Long
    
    USBDevNum = 1                       ' default device number
    objDppApi = OpenDppApi()            ' create/open DPPAPI
    NumDev = OpenUSBDevice(objDppApi)   ' open communications default USB device
    If ((objDppApi = 0) Or (NumDev = 0)) Then
        StatusList "No DPP devices detected", vbRed
        Exit Sub             'exit sub if api is not present
    End If

    'Display connection status
    StatusList CStr(NumDev) & " DPP devices detected", vbDarkGreen
    StatusList "Default device (" & CStr(USBDevNum) & ") selected", vbBlack

    'Display DPP Device Infomation
    DppDevice = GetUSBDppDeviceInfo(objDppApi, USBDevNum, DppSerialNumber) ' get device information
    strDeviceType = DPPTypeString(DppDevice)
    StatusList "Serial Number " & CStr(DppSerialNumber), vbBlack
    StatusList "DPP Device Type " & strDeviceType, vbBlack
 
    DisplayDPPStatus objDppApi
    If (DppDevice = DPPDP5) Then
        cmdGetDP5Text objDppApi
    End If
    CloseDppApi (objDppApi)
    objDppApi = 0

End Sub

Private Sub DisplayDPPStatus(objDppApi As Long)
    'Dim StatusLst As DPP_STATUS                 'holds copy of current status
    'Dim Result As Boolean
    'Result = VBGetDppStatus(objDppApi, StatusLst)
    Dim szStatus As String * 2000           ' status text
    GetStatusString objDppApi, isBufferA, szStatus, 2000       ' get device status
    StatusList szStatus, vbBlack
End Sub


'reads DP5 stored text
Private Sub cmdGetDP5Text(objDppApi As Long)
    Dim cstrDP5Text As String * 1024
    GetDP5Text objDppApi, cstrDP5Text, 1024
    StatusList "Get DP5 Text", vbDarkGreen
    txtDP5Text.Text = cstrDP5Text
End Sub

Private Sub cmdDP5SetText_Click()
    Dim NumDev As Integer       'number of usb devices
    Dim objDppApi As Long       'pointer to dpp api
    Dim strDeviceType As String 'device type name
    Dim USBDevNum As Long
    
    USBDevNum = 1                       ' default device number
    objDppApi = OpenDppApi()            ' create/open DPPAPI
    NumDev = OpenUSBDevice(objDppApi)   ' open communications default USB device
    If ((objDppApi = 0) Or (NumDev = 0)) Then
        StatusList "No DPP devices detected", vbRed
        Exit Sub             'exit sub if api is not present
    End If

    'Display connection status
    StatusList CStr(NumDev) & " DPP devices detected", vbDarkGreen
    StatusList "Default device (" & CStr(USBDevNum) & ") selected", vbBlack

    'Display DPP Device Infomation
    DppDevice = GetUSBDppDeviceInfo(objDppApi, USBDevNum, DppSerialNumber) ' get device information
    strDeviceType = DPPTypeString(DppDevice)
    StatusList "Serial Number " & CStr(DppSerialNumber), vbBlack
    StatusList "DPP Device Type " & strDeviceType, vbBlack

    DisplayDPPStatus objDppApi
    If (DppDevice = DPPDP5) Then
        cmdSetDP5Text objDppApi
    End If
    CloseDppApi (objDppApi)
    objDppApi = 0

End Sub

'saves px4 stored text
Private Sub cmdSetDP5Text(objDppApi As Long)
    Dim cstrNewDP5Text As String
    Dim Response As Long
    Dim Msg As String
    Dim Title As String
    Dim Style As Long

    cstrNewDP5Text = Left(txtDP5Text.Text, 512)
    cstrNewDP5Text = Trim(cstrNewDP5Text)
    If Len(cstrNewDP5Text) = 0 Then
        Msg = "There is no text to send. This will erase any text stored. " & vbNewLine
        Msg = Msg & "Do you want to send a null string to the DP5?"
        Style = vbYesNo + vbCritical + vbDefaultButton2
        Title = "DP5 Set Text Demonstration"
        Response = MsgBox(Msg, Style, Title)
        If Response = vbNo Then
            Exit Sub
        End If
    End If
    SetDP5Text objDppApi, cstrNewDP5Text
    StatusList "Set DP5 Text", vbDarkGreen
End Sub

'hardware added to the FPGA to measure the interval between resets for test setup
'looks for an occasional short reset followed by a normal reset
'the circuit reports the previous two reset intervals
'The two intervals are 12-bit values in the status packet
'Has resolution of 13.11mS/count. (The actual resolution is (2^18)/(20E6) )
'Requires FPGA v4.03 or later, and firmware v4.03 or later.
'
'Details:
'   The two 12-bit values are packed into 3 bytes as follows:
'       Status offset 37d = LSB of previous reset interval
'       Status offset 38d, D3-D0 = MS nibble of previous reset interval
'       Status offset 38d, D7-D4 = LS nibble of current reset interval
'       Status offset 39d = MSB of current reset interval (note this is multiplied by 16, not 256, since the LS is a nibble not a byte.)

Private Sub cmdGetPC5Status_Click()
    Dim NumDev As Integer       'number of usb devices
    Dim objDppApi As Long       'pointer to dpp api
    Dim strDeviceType As String 'device type name
    Dim USBDevNum As Long
    Dim Status(64) As Byte                          'get copy of status buffer in byte format
    Dim szStatus As String * 2000   ' status text
    
    USBDevNum = 1                       ' default device number
    objDppApi = OpenDppApi()            ' create/open DPPAPI
    NumDev = OpenUSBDevice(objDppApi)   ' open communications default USB device
    If ((objDppApi = 0) Or (NumDev = 0)) Then
        StatusList "No DPP devices detected", vbRed
        Exit Sub             'exit sub if api is not present
    End If
    
    'Display connection status
    StatusList CStr(NumDev) & " DPP devices detected", vbDarkGreen
    StatusList "Default device (" & CStr(USBDevNum) & ") selected", vbBlack
    
    'Display DPP Device Infomation
    DppDevice = GetUSBDppDeviceInfo(objDppApi, USBDevNum, DppSerialNumber) ' get device information
    strDeviceType = DPPTypeString(DppDevice)
    StatusList "Serial Number " & CStr(DppSerialNumber), vbBlack
    StatusList "DPP Device Type " & strDeviceType, vbBlack
    
    If ((DppDevice = DPPDP4EMUL) Or (DppDevice = DPPDP5)) Then
        GetStatusString objDppApi, 1, szStatus, 2000 ' get device status
        'Run GetStatusStruct or GetStatusString before running Get80MHzMode
        Dpp80MHzMode = Get80MHzMode(objDppApi)          'global setting
        SetFPGAClockDefault objDppApi, Dpp80MHzMode, DppDevice
    End If
    bConfigHVPolarity = True      ' true=+, false=-, set to + as default, only - for SDD
    HVPolarityError = False
    Firmware = 0                  'embedded code version used to test for dpp options
    If (DppDevice > DPPDP4) Then  'process sdd and pc5 support
        GetStatusBuffer objDppApi, isBufferA, VarPtr(Status(0)) 'get status bytes for advanced processing
        ProcessBootBlock Status
        If (DppDevice = DPPPX4) Then
            SDD_PX4_HV              'test for px4 with sdd support (has negative high voltage)
        End If
        If (DppDevice = DPPDP5) Then
            ProcessPC5_Status Status
        End If
        DisplayHVPolarity bConfigHVPolarity, HVPolarityError
    Else
        bb_DeadTimeCounter = 0
        bb_DiodeCalDACSet = 0
        bb_TECCurrentLimit = 0
        bb_BootFlags = 0
        bb_HVDACSet = 0
        bb_TECDACSet = 0
        bb_InputOffsetTuning = 0
        bb_uCTempCal = 0
        bb_SpectrumOffset = 0
        NeedsDP5ReBoot = False
        b80MHzMode = False
    End If
    CloseDppApi (objDppApi)
    objDppApi = 0
End Sub

Private Function DisplayHVPolarity(bConfigHVPolarity As Long, Optional HVPolarityError As Boolean = False) As String
    Dim strSign As String
    Dim rgbCol As Long
    
    If (bConfigHVPolarity) Then
        strSign = "+ HV Polarity "
        rgbCol = vbBlue
    Else
        strSign = "- HV Polarity "
        rgbCol = vbMagenta
    End If
    If (HVPolarityError) Then rgbCol = vbRed
    StatusList strSign & strHVMonitor, rgbCol
End Function

Private Sub SDD_PX4_HV()
    If (DppDevice = DPPPX4) Then       ' PX4 device specific tests
        If (Firmware = &H45) Then          ' Need to show negative HV for PX4 SDD
            bConfigHVPolarity = False
            StatusList "PX4 SDD Support Detected", vbCoral
            strHVMonitor = Format(HVMonitor, "-0.0V")   ' put minus sign in string
        Else
            strHVMonitor = Format(HVMonitor, "0.0V")   ' hv string
        End If
    End If
End Sub

''PC5 Status' byte to the DP5 status packet - it's at offset 43d.
'    D7: 1=PC5 detected, 0=PC5 not detected
'    D6: 1=+HV, 0=-HV
'    D5: 1=8.5V, 0=5V
'    D4 -D0: TBD
Private Sub ProcessPC5_Status(Status() As Byte)
    Dim PreAmpSupply8_5 As Long
    If (DppDevice = DPPDP5) Then        ' DP5 device specific tests
        If (Firmware >= &H54) Then                  ' if (FW > 5.04) check for pc5 status
            'DP5 PC5 Status byte at offset 43d &H2B .
            'These are detected at power-up and are static
            'D5: 1=8.5V, 0=5V      ' won't show now
            'D4-D0: TBD            ' NA
            bPC5Detected = ShiftRight((Status(43) And &H80), 7)      'D7: 1=PC5 detected, 0=PC5 not detected
            If (bPC5Detected) Then
                StatusList "PC5 Detected", vbBlueViolet
                bConfigHVPolarity = ShiftRight((Status(43) And &H40), 6)         'D6: 1=+HV, 0=-HV
                bBootHVPolarity = ShiftRight((bb_BootFlags And &H8), 3)     ' D3 HV Polarity
                PreAmpSupply8_5 = ShiftRight((Status(43) And &H20), 5)         'D5: 1=8.5V, 0=5V
                If (PreAmpSupply8_5 = 0) Then
                    StatusList "PreAmp Supply Jumpered To 5V", vbSteelBlue
                Else
                    StatusList "PreAmp Supply Jumpered To 8.5V", vbSlateBlue
                End If
                If (Not CBool(bBootHVPolarity)) Then
                    strHVMonitor = Format(HVMonitor, "-0.0V")   ' put minus sign in string
                Else
                    strHVMonitor = Format(HVMonitor, "0.0V")   ' hv string
                End If
                If (bConfigHVPolarity <> bBootHVPolarity) Then      ' this is a cfg error
                    strHVMonitor = " Check Polarity"
                    HVPolarityError = True
                End If
            End If
        End If
    End If
End Sub

Private Function ShiftLeft(ByVal value As Long, ByVal Shift As Integer) As Long
    If (Shift = 0) Then    'shifting 0 returns unshifted value
        ShiftLeft = value
    ElseIf (Shift = 31) Then    'shifting 31 causes vb overflow error
        If ((value And &H1) = 0) Then
            ShiftLeft = 0
        Else
            ShiftLeft = &H80000000
        End If
    ElseIf (Shift > 31) Then    'shifting 31 causes vb overflow error
        ShiftLeft = 0
    Else
        SaveSetBits
        If (value And (2 ^ (31 - Shift))) Then GoTo OverFlow
        ShiftLeft = ((value And SetBits(31 - Shift)) * (2 ^ Shift))
    End If
    Exit Function
OverFlow:
    ShiftLeft = ((value And SetBits(31 - (Shift + 1))) * (2 ^ (Shift))) Or &H80000000
End Function

Private Function ShiftRight(ByVal value As Long, ByVal Shift As Integer) As Long
    Dim hi As Long
    If (Shift = 0) Then         'shifting 0 returns unshifted value
        ShiftRight = value
    ElseIf (Shift = 31) Then    'shifting 31 causes vb overflow error
        ShiftRight = IntBool(Not ((value And &H80000000) = 0))
    ElseIf (Shift > 31) Then    'shifting 31 causes vb overflow error
        ShiftRight = 0
    Else
        SaveSetBits
        If (value And &H80000000) Then hi = &H40000000
        ShiftRight = (value And &H7FFFFFFE) \ (2 ^ Shift)
        ShiftRight = (ShiftRight Or (hi \ (2 ^ (Shift - 1))))
    End If
End Function

'creates set bit values,
Private Sub SaveSetBits()
    Dim i As Integer
    Dim value As Long

    For i = 0 To 30
        value = value + (2 ^ i)
        SetBits(i) = value
        'Debug.Print "2^" & i & " = &H" & Hex(value) & " SetBits(" & i & ") = &H" & Hex(SetBits(i))
    Next i
    SetBits(i) = value + &H80000000
    'Debug.Print "2^" & i & " = &H" & Hex(value) & " SetBits(" & i & ") = &H" & Hex(SetBits(i))
End Sub

Private Function IntBool(vbBool As Boolean) As Integer
    If (vbBool) Then
        IntBool = 1
    Else
        IntBool = 0
    End If
End Function

Private Sub cmdLoad_Click()
    txtHex = "FFFFFFFF"
End Sub

Private Sub cmdShiftLeft_Click()
    Dim lHex As Long
    Dim iShift As Integer
    lHex = CLng("&H" & txtHex)
    iShift = CInt(txtSL)
    lHex = ShiftLeft(lHex, iShift)
    txtHex = Hex(lHex)
End Sub

Private Sub cmdShiftRight_Click()
    Dim lHex As Long
    Dim iShift As Integer
    lHex = CLng("&H" & txtHex)
    iShift = CInt(txtSR)
    lHex = ShiftRight(lHex, iShift)
    txtHex = Hex(lHex)
End Sub

Private Sub ProcessBootBlock(Status() As Byte)
    Dim HVTemp As Long
'16-byte DP5 boot block in the status packet
'@mfunc <c CDppConfig> Process status and save values to status variables
'@parm status buffer
'@comm updates status of the following variables:
'@iex
    Firmware = Status(13)  'embedded code version
    HVTemp = ShiftLeft((Status(18) And &HF), 8) + CLng(Status(19))
    HVMonitor = (CDbl(HVTemp) / 4#) * 2#    ' "V"

    'Read only
    bb_DeadTimeCounter = LongWordToDouble(&H2F, Status)             '&H2F-&H2C deadtime counter 50nS/count

    ' review old cal details
    bb_DiodeCalDACSet = ShiftLeft(Status(&H31), 8) + CLng(Status(&H30))      '&H30-31 Diode Cal DAC setting

    ' need more details (valid values & devices)
    bb_TECCurrentLimit = ShiftLeft(Status(&H33), 8) + CLng(Status(&H32))     '&H32-33 TEC current limit DAC setting (not used in DP5)

    ' set in BootOptions Dialog, willbe set with boot options dialog
    bb_BootFlags = ShiftLeft(Status(&H35), 8) + CLng(Status(&H34))           '&H34-35 Boot flags (MSB currently unused)
    NeedsDP5ReBoot = ShiftRight((bb_BootFlags And &H80), 7)         ' D7 Boot device mode
    b80MHzMode = ShiftRight((bb_BootFlags And &H10), 4)             ' D4 FPGA clock

    ' same as px4 configuration
    bb_HVDACSet = ShiftLeft(Status(&H37), 8) + CLng(Status(&H36))            '&H36-37 HV DAC setting (not used in PX4 mode)

    ' same as px4 configuration
    bb_TECDACSet = ShiftLeft(Status(&H39), 8) + CLng(Status(&H38))           '&H38-39 TEC DAC setting (not used in PX4 mode)

    ' same as px4 configuration
    bb_InputOffsetTuning = ShiftLeft(Status(&H3B), 8) + CLng(Status(&H3A))   '&H3A-3B Input offset DAC setting (not used in PX4 mode) (not currently used - testing to see if constant value works)

    ' need more details (valid values & devices)
    bb_uCTempCal = ShiftLeft(Status(&H3D), 8) + CLng(Status(&H3C))           '&H3C-3D uC temp cal, or something like that (not used yet)

    ' need more details (valid values & devices)
    bb_SpectrumOffset = ShiftLeft(Status(&H3F), 8) + CLng(Status(&H3E))      '&H3E-3F Spectrum offset (not used yet, added a boot flag bit (D1) to indicate whether to use this)
End Sub

' convert a 4 byte long word to a double
' lwStart - starting index of longword
' buffer - byte buffer
Private Function LongWordToDouble(lwStart As Integer, buffer() As Byte) As Double
    Dim dblVal As Double
    Dim j As Integer
    Dim ByteMask As Double
    dblVal = 0
    For j = 0 To 3    ' build 4 bytes (lwStart-lwStart+3) into double
        ByteMask = 2 ^ (8 * j)
        dblVal = dblVal + (buffer((lwStart + j)) * ByteMask)
    Next
    LongWordToDouble = dblVal
End Function

Private Sub ClearStatusList()
    rtbStatus.Text = ""
End Sub

'USEAGE: StatusList  msg, RGB(127, 0, 0)
'USEAGE: StatusList  msg, vbRed
Private Sub StatusList(strStatus As String, clrColor As Long, Optional bNL As Boolean = True)
    Dim prvlen As Long
    Dim strNL As String
    ' StatusList  appends colored text to a rich text edit (RTE) box. Since
    ' you can't just do Ctrl.Text = Ctrl.Text + newtext (you'd overwrite all
    ' the old formatting, you have to move the insertion point to the end
    ' and insert new text.

    ' Find the location the new text will start (at the end of the old text)
    prvlen = Len(rtbStatus.Text)
    ' Move the insertion point to the end of the RTE box
    rtbStatus.SelStart = Len(rtbStatus.Text) + 1
    ' Replace the selection (which is nothing right now) with the new
    ' text, appending it without changing the previous formatting.
    strNL = ""
    If (bNL) Then strNL = vbNewLine
    rtbStatus.SelText = strStatus & strNL
    ' Now select the entire inserted text
    rtbStatus.SelStart = prvlen
    rtbStatus.SelLength = Len(strStatus & strNL)
    ' Change the selected (newly inserted) text to the requested color
    rtbStatus.SelColor = clrColor
    ' Move the insertion point back to the end of the RTE
    rtbStatus.SelStart = Len(rtbStatus.Text) + 1
End Sub

